# coding: utf-8

"""
    FINBOURNE Candela Platform Web API

    FINBOURNE Technology  # noqa: E501

    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic.v1 import BaseModel, StrictStr

class Circuit(BaseModel):
    """
    A class that represents a flow of states (circuits) that constitutes the control flow logic of an agent or pipeline.  # noqa: E501
    """
    first: Optional[StrictStr] = None
    current: Optional[StrictStr] = None
    nodes: Optional[Any] = None
    additional_properties: Dict[str, Any] = {}
    __properties = ["first", "current", "nodes"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def __str__(self):
        """For `print` and `pprint`"""
        return pprint.pformat(self.dict(by_alias=False))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Circuit:
        """Create an instance of Circuit from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        # set to None if first (nullable) is None
        # and __fields_set__ contains the field
        if self.first is None and "first" in self.__fields_set__:
            _dict['first'] = None

        # set to None if current (nullable) is None
        # and __fields_set__ contains the field
        if self.current is None and "current" in self.__fields_set__:
            _dict['current'] = None

        # set to None if nodes (nullable) is None
        # and __fields_set__ contains the field
        if self.nodes is None and "nodes" in self.__fields_set__:
            _dict['nodes'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Circuit:
        """Create an instance of Circuit from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Circuit.parse_obj(obj)

        _obj = Circuit.parse_obj({
            "first": obj.get("first"),
            "current": obj.get("current"),
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj
