# coding: utf-8

"""
    FINBOURNE Candela Platform Web API

    FINBOURNE Technology  # noqa: E501

    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict
from pydantic.v1 import BaseModel, Field, StrictStr, validator

class TraceItem(BaseModel):
    """
    TraceItem
    """
    item_type: StrictStr = Field(...)
    content: StrictStr = Field(...)
    additional_properties: Dict[str, Any] = {}
    __properties = ["item_type", "content"]

    @validator('item_type')
    def item_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('user', 'sys', 'chat_resp', 'struct_resp', 'info', 'result', 'wait'):
            raise ValueError("must be one of enum values ('user', 'sys', 'chat_resp', 'struct_resp', 'info', 'result', 'wait')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def __str__(self):
        """For `print` and `pprint`"""
        return pprint.pformat(self.dict(by_alias=False))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TraceItem:
        """Create an instance of TraceItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TraceItem:
        """Create an instance of TraceItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return TraceItem.parse_obj(obj)

        _obj = TraceItem.parse_obj({
            "item_type": obj.get("item_type"),
            "content": obj.get("content")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj
